; Disassembly of Stampede.bin
; Disassembled Sun Jan 12 18:02:21 2014
; Using DiStella v3.0
;
; Command Line: ..\pinball\distella\distella.exe Stampede.bin
;

hposp0	= $d000
hposp1	= $d001
sizep0	= $d008
sizep1	= $d009
p1pl	= $d00d
grafp0	= $d00d
grafp1	= $d00e
trig0	= $d010
colpm0	= $d012
colpm1	= $d013
colpf0	= $d016
colbk	= $d01a
hitclr	= $d01e
consol	= $d01f

audf1	= $d200
audc1	= $d201
audf2	= $d202
audc2	= $d203
audf3	= $d204
audc3	= $d205
audf4	= $d206
audc4	= $d207
audctl	= $d208
irqen	= $d20e

porta	= $d300

dmactl	= $d400
dlistl	= $d402
wsync	= $d40a
vcount	= $d40b
nmien	= $d40e

VSYNC   =  $00
VBLANK  =  $01
NUSIZ0  =  $04
NUSIZ1  =  $05
COLUPF  =  $08
CTRLPF  =  $0A
REFP1   =  $0C
PF0     =  $0D
RESP0   =  $10
RESP1   =  $11
RESM1   =  $13
_audc0   =  $15
_audc1   =  $16
_audf0   =  $17
_audf1   =  $18
_audv0   =  $19
_audv1   =  $1A
ENAM0   =  $1D
ENAM1   =  $1E
HMP0    =  $20
HMP1    =  $21
HMM0    =  $22
HMM1    =  $23
VDELP1  =  $26
HMOVE   =  $2A
HMCLR   =  $2B
_inpt4	= $40
_cxm0p	= $41
_cxppmm	= $42
_tmp0	= $43

;$8B-8C = player HMOVE pointer
;$8D-8E = player/lasso HMM0/ENAM0/NUSIZ0 data
;$8F-90 = player graphic pointer
;$91-92 = cow graphic pointer
;$93-94 = cow HMOVE pointer
;$95    = kernel temporary
;$9B-A0 = cow ?
;$B6    = player vertical position
;$CA-CF = cow NUSIZ mode
;$D0-D5 = cow horizontal positions
;$DD-E2 = cow collision flags
;	D7 = player+cow collision
;	D6 = m0m1 + m0p1 collision
;	D5 = m0p0 collision
;$E3-E8 = cow animation frame ($00, $08, $10, $18)
;$EC-F1 = cow graphic table pointer LSB
;$F2-F7 = cow HMOVE table pointer LSB
;$F8-FF = stack space

SWCHA   =  $0280
SWCHB   =  $0282
;INTIM   =  $0284
TIM64T  =  $0296

;==========================================================================	
		org	$2800

;==========================================================================
		.pages 1
audio_tabs:
audio_lotab:
		:32 dta <((#+1)*57-7)
		:32 dta >((#+1)*57-7)

audio_poly4tab:
		:32 dta <((#+1)*57-(((#+1)*57)%15)-1-7)
		:32 dta >((#+1)*57-(((#+1)*57)%15)-1-7)

audio_lotab6:
		:32 dta <((#+1)*57*3-7)
		:32 dta >((#+1)*57*3-7)

audio_lotab31:
		:32 dta <(((#+1)*57*31)/2-7)
		:32 dta >(((#+1)*57*31)/2-7)
		.endpg

;==========================================================================
.proc	updateAudio
		lda		_audc0
		and		#$0f
		tax
		lda		_audf0
		and		#$1f
		ora		audio_dtab,x
		tax
		mva		audio_tabs,x audf1
		mva		audio_tabs+$20,x audf2

		lda		_audc1
		and		#$0f
		tax
		lda		_audf1
		and		#$1f
		ora		audio_dtab,x
		tax
		mva		audio_tabs,x audf3
		mva		audio_tabs+$20,x audf4
		
		lda		_audc0
		and		#$0f
		tax
		lda		_audv0
		and		#$0f
		ora		audio_ctab,x
		sta		audc2		

		lda		_audc1
		and		#$0f
		tax
		lda		_audv1
		and		#$0f
		ora		audio_ctab,x
		sta		audc4
		rts
.endp

audio_ctab:
		dta		$10
		dta		$c0		;$1: 4-bit polynomial
		dta		$20
		dta		$30
		dta		$a0		;$4: pure tone
		dta		$a0		;$5: pure tone
		dta		$a0		;$6: pure tone
		dta		$70
		dta		$80		;$8: 9-bit polynomial
		dta		$90
		dta		$A0
		dta		$B0
		dta		$a0		;$C: pure tone, div 6
		dta		$D0
		dta		$E0
		dta		$20		;$F: 5-bit poly, div 6
		
audio_dtab:
		dta		<audio_lotab
		dta		<audio_poly4tab
		dta		<audio_lotab
		dta		<audio_lotab
		dta		<audio_lotab
		dta		<audio_lotab
		dta		<audio_lotab31
		dta		<audio_lotab
		dta		<audio_lotab
		dta		<audio_lotab
		dta		<audio_lotab
		dta		<audio_lotab
		dta		<audio_lotab6
		dta		<audio_lotab
		dta		<audio_lotab
		dta		<audio_lotab6

;==========================================================================	
__init:
		sei
		mva		#0 irqen
		mva		#0 nmien
		
		lda		#124
		cmp:rne	vcount
		
		mwa		#dlist dlistl
		mva		#$22 dmactl
		
		mva		#$f8 audctl
		mva		#0 _cxm0p
		mva		#0 _cxppmm
		mva		#$80 _inpt4
		
		mva		#$80 hposp0
		mva		#$88 hposp1
		mva		#$01 sizep0
		mva		#$00 sizep1
		
		ldx		#20*7
		lda		#0
		sta:rne	pf_banner-1,x-
		ldx		#20*7
		sta:rne	pf_score-1,x-
		
		jmp		start
	
;==========================================================================	
.proc update8
		lda		porta
		asl
		asl
		asl
		asl
		sta		swcha
		lda		consol
		and		#$03
		ora		#$08
		sta		swchb
		
		lda		trig0
		lsr
		ror
		sta		_inpt4
		
		jsr		updateAudio
		rts
.endp
		
;==========================================================================	
		org	$3000

start:
		SEI
		CLD
		LDX    #$00
		TXA
LF005: STA    VSYNC,X
		TXS
		INX
		BNE    LF005
		TAY
		DEC    $99
		JMP    LF1F0
LF011: LDX    #$08
		LDY    #$A5
LF015: asl
		asl
		asl
LF018: AND    #$78
		BEQ    LF020
		LDY    #$00
		BEQ    LF024
LF020: TXA
		BEQ    LF024
		TYA
LF024: STA    $81,X
		DEX
		DEX
		RTS

;==========================================================================
LF029: LDA    #$00
		STA    ENAM0
		STY    $95
		STA    WSYNC
		;STA    HMOVE
		BCS    LF067
LF035: LDX    $C0
		INX
LF038:
		lda		#<[LF6A5-1]
		STA    $91
		BNE    LF04A
LF03E: TXA
		TAY
		LDA		($91),Y			;load animal graphic
		STA    grafp1
		LDA    ($93),Y
		STA    HMP1
		LDY    $95
LF04A: DEY
		CPY    #$1A
		BCS    LF029
		
		sta		wsync
		
		LDA    ($8B),Y
		STA    HMP0
		AND    #$05
		ORA    ($8D),Y
		STA    HMM0
		EOR    #$20
		STA    ENAM0
		AND    #$FD
		STA    NUSIZ0
		LDA    ($8F),Y
		;STA    HMOVE
		STY    $95
LF067: DEX
		sta		grafp0			;update player graphic
		BNE    LF03E
		STX    grafp1
		DEC    $98
		BEQ    LF035
		BMI    LF0B9
		DEY
		CPY    #$1A
		TXA
		LDX    $98
		BCS    LF090
		LDA    ($8B),Y			;load player HMOVE/lasso data
		STA    HMP0
		AND    #$05
		ORA    ($8D),Y			;merge in lasso HMOVE value
		STA    HMM0
		EOR    #$20
		STA    ENAM0
		AND    #$FD
		STA    NUSIZ0
		LDA    ($8F),Y
LF090: DEY
		CPY    #$1A
		STA    WSYNC
		;STA    HMOVE
		STA    grafp0
		LDA    $D5,X
		LDX    #$40
		ORA    #$00
		BMI    LF0C5
		
		;reposition cow
;		BEQ    LF0A5
;		TAX
;LF0A4: DEX
;LF0A5: BNE    LF0A4
;		STA    RESP1
;		STX    HMP1

.if 0
		php
		sty		_tmp0
		tax
		ldy		$98
		lda		$c9,y
		lsr
		lsr
		lsr
		lsr
		eor		#$07
		clc
		adc		cow_htab,x
		sta		hposp1
		ldx		#0
		ldy		_tmp0
		plp
.else
		php
		ldx		$98
		lda		$cf,x
		clc
		adc		#$30
		sta		hposp1
		ldx		#0
		plp
.endif

		BCS    LF0D5
		LDA    ($8B),Y
		STA    HMP0
		AND    #$05
		ORA    ($8D),Y
		STA    HMM0
		BCC    LF0EE
LF0B9:
		lda		_cxm0p
		lsr
		ORA    colpm1
		STA    $DC
		STX    REFP1
		JMP    LF157
		
LF0C5:
;		TAX
;		LDA    #$00
;		STA    HMP1
		BCC    LF0DF
;		INX
;		INX
		DEC    $96
;LF0D0: DEX
;		BMI    LF0D0
;		STA    RESP1

		php
		sty		_tmp0
		tax
		ldy		$98
		lda		$c9,y
		lsr
		lsr
		lsr
		lsr
		eor		#$07
		clc
		adc		cow_htab,x
		sta		hposp1
		ldx		#0
		ldy		_tmp0
		plp


LF0D5: STA    WSYNC
		;STA    HMOVE
		LDA    #$00
		STA    ENAM0
		BEQ    LF0FC
LF0DF: LDA    ($8B),Y
		STA    HMP0
		AND    #$05
		ORA    ($8D),Y
		STA    HMM0
LF0E9: DEX
		BMI    LF0E9
		STA    RESP1
LF0EE: STA    WSYNC
		;STA    HMOVE
		EOR    #$20
		STA    ENAM0
		AND    #$FD
		STA    NUSIZ0
		LDA    ($8F),Y
LF0FC: STA    grafp0
		DEY
		LDX    $98
		CPY    #$1A
		BCS    LF136
		SEC
LF106: LDA    ($8B),Y
		STA    HMP0
		AND    #$05
		ORA    ($8D),Y
		STA    HMM0
		EOR    #$20
		STA    ENAM0
		AND    #$FD
		STA    NUSIZ0
		LDA    ($8F),Y
		BCS    LF138
LF11C:
		STA    WSYNC
		;STA    HMOVE
		sta		grafp0			;update player graphic
		LDA    $DB,X
		STA    colpm1

		;get collision status		
;		LDA		_cxm0p
;		lsr
;		ORA    _cxppmm
;		STA    $DC,X

		lda		p1pl
		lsr
		lda		#0
		ror
		sta		$dc,x

		
		LDX    #$10
		STA    hitclr
		STA    HMCLR
		JMP    LF04A
LF136: LDA    #$00
LF138: DEY
		STA    WSYNC
		;STA    HMOVE
		STA    grafp0
		LDA    $EB,X
		STA    $91
		LDA    $F1,X
		STA    $93
		LDA    $C9,X
		STA    NUSIZ1
		STA    REFP1
		STA    HMP1				;set hmove for cow fine pos
		CPY    #$1A
		BCC    LF106
		LDA    #$00
		BEQ    LF11C
LF157: STX    _audc0
		STX    grafp0
LF15B: STA    WSYNC
		LDA    $B5
		LDX    #$35
		JSR    LF1B2
		asl
		STA    RESP0
		STX    CTRLPF
		STX    PF0
		STX    _audv0
		LDX    #$03
		LDY    #$13
		STA    RESP1
		STY    NUSIZ0
		STY    NUSIZ1
		STY    _audf1
		EOR    #$80
		STA    HMCLR
		STA    RESM1
LF17F: STA    HMP0
		STA    HMP1
		STA    HMM1
		STA    WSYNC
		;STA    HMOVE
		LDA    $FA
		STA    colbk
		STA    colpm1
		STA    colpm0
		STY    ENAM1
		LDA    #$30
		STY    VDELP1
		STA    grafp1
		STA    grafp0
		STA    WSYNC
		STA    WSYNC
		LDA    $FB
		STA    colbk
		STA    WSYNC
		STA    WSYNC
		LDA    #$1D
		DEX
		BNE    LF17F
		STA    WSYNC
		STX    grafp1
		STX    grafp0
LF1B2: STX    ENAM1
		RTS

LF1B5:
;		LDY    INTIM
;		BNE    LF1B5
		ldy		#0
		
		STA    WSYNC
		STX    VSYNC
		INC    $80
		BNE    LF1C8
		INC    $BB
		BNE    LF1C8
		STX    $BA
LF1C8: TXA
		EOR    SWCHB
		AND    #$08
		asl
		SBC    #$00
		BIT    $BA
		BPL    LF1D7
		AND    #$F7
LF1D7: STA    $E9
		LDX    #$04
LF1DB: LDA    $BB
		AND    $BA
		EOR    LF6FB,X
		AND    $E9
		STA    $F7,X
		STA    NUSIZ1,X
		DEX
		STX    $E2
		BNE    LF1DB
		LDA    SWCHB
LF1F0: LDX    #$2D
		lsr
		ror
		STA    WSYNC
		STY    VSYNC
		STX    TIM64T
		BMI    LF219
		
		;reset game variables
		LDX    #$0C
LF1FF: LDA    LF798,X
		STA    $BD,X
		STA    $CB,X
		STY    $99,X
		STY    $A5,X
		STY    $B1,X
		DEX
		BNE    LF1FF
		LDA    $99
		AND    #$02
		BEQ    LF219
		ORA    $80
		STA    $C7
LF219:
		TYA
		BCS    LF23A
		LDX    $99
		DEC    $97
		BPL    LF23C
		INX
		TXA
		AND    #$07
		STA    $99
		ADC    #$01
		STA    $B8
		STA    $B9
		LDX    #$04
		TYA
LF231: STA    $BA,X
		DEX
		BPL    LF231
		STX    $9A
		LDA    #$1D
LF23A: STA    $97
LF23C: LDX    $B6
		LDA    SWCHA
		asl
		asl
		asl
		BCS    LF249
		DEX
		BCC    LF24C
LF249: BMI    LF250
		INX
LF24C: STY    $BA
		STY    $BB
LF250: TXA
		CMP    #$69
		BIT    $9A
		LDX    $B3
		BVS    LF2D7
		BCS    LF261
		CPX    #$04
		BCS    LF261
		STA    $B6
LF261: LDA    $BF
		lsr
		lsr
		lsr
		CLC
		ADC    $B5
		TAY
		BNE    LF27C
		BIT    $BF
		BMI    LF27C
		INC    $BF
		LDX    #$03
		CPX    $99
		BCS    LF27C
		LDX    #$80
		STX    $BF
LF27C: EOR    $B5
		STA    $EA
		AND    #$38
		BEQ    LF29C
		DEC    $E2
		CMP    #$20
		AND    #$08
		BNE    LF28E
		DEC    $E2
LF28E: LDX    #$01
		BIT    $B3
		BMI    LF29A
		BCC    LF29C
		TYA
		BMI    LF29C
		INX
LF29A: STX    _audc0
LF29C: STY    $B5
		TYA
		INC    $B4
		asl
		rol
		rol
		rol
		AND    #$03
		TAY
		LDA    $B4
		LDX    $B3
		BMI    LF2BE
		CPX    #$04
		BCS    LF2BA
		BIT    _inpt4
		BMI    LF2BC
		LDX    #$24
		LSR    $EB
LF2BA: AND    $EB
LF2BC: AND    #$07
LF2BE: asl
		BNE    LF2D7
		CPX    #$14
		BEQ    LF2D0
		CPX    #$18
		BNE    LF2D2
		BIT    SWCHB
		BVC    LF2D2
		LDX    #$10
LF2D0: ROL    $EB
LF2D2: DEX
		BPL    LF2D7
		LDX    #$03
LF2D7: STX    $B3
		BPL    LF2DD
		LDY    #$04
LF2DD: LDA    LF5F6,Y
		STA    $8F
		LDA    LF7AB,Y
		STA    $8B
		LDA    #$13
		LDY    #<LF6C7
		INX
		BNE    LF2F3
		LDA    $B4
		lsr
		LDY    #$C3
LF2F3:	STA    _audf0

		LDA    LF5F1,X
		CPX    #$05
		BCC    LF30B
		TXA
		SBC    #$05
		CMP    #$10
		BCC    LF305
		EOR    #$1F
LF305: CLC
		ADC    #<LF6C7
		TAY
		LDA    #$1F
LF30B: STY    $8D
		LDX    #$02
		JSR    LF5BD
		jsr		LF7E4		;reposition missile 0
		LDX    #$05
LF317:
		LDY    $A7,X
		LDA    $AD,X
		BPL    LF334
		INC    $D0,X
		SEC
		LDA    #$30
		SBC    $A1,X
		BCC    LF32E
		SBC    $AD,X
		CMP    $D0,X
		LDA    #$F7
		BCS    LF35C
LF32E: LDA    $AD,X
		SBC    #$9C
		STA    $AD,X
LF334: CPY    #$03
		BCS    LF33F
		LDA    LF7FD,Y
		BIT    $EA
		BEQ    LF34B
LF33F: LDA    $E2
		BCS    LF346
		CMP    #$80
		ror
LF346:
		;update cow horizontal position
		CLC
		ADC    $D0,X
		STA    $D0,X
		
LF34B: LDA    LF6D8,Y
		EOR    #$F8
		BPL    LF362
		BIT    $EA
		BEQ    LF364
		LDA    $E2
		AND    #$3E
		asl
		asl
LF35C:	ADC    $E3,X		;advance animation frame
		BPL    LF362
		LDA    #$18
LF362:	STA    $E3,X		;update animation frame
LF364: LDA    $BB
		AND    $BA
		EOR    LF5FB,Y
		AND    $E9
		STA    $DC,X
		LDA    #$FF
		JSR    LF585
		BCS    LF3EA
		CPY    #$04
		BCC    LF38E
		LDA    #$04
		CMP    $A7,X
		BEQ    LF38E
		STA    _audc1
		LDA    #$FF
		
		;!! cheat miss count
		lda		#$04
		sta		$be
		
		DEC    $BE
		BPL    LF38A
		INC    $BE
LF38A: BNE    LF38E
		STA    $9A
LF38E: LDY    $9B,X
		BNE    LF3EA
		STY    $E3,X
		LDA    $AD,X
		SEC
		SBC    #$0C
		BPL    LF39C
		TYA
LF39C: STA    $AD,X
		INC    $C1,X
		LDA    $99
		lsr
		lsr
		LDA    $C1,X
		BCC    LF3AA
		EOR    $C9
LF3AA: PHA
		AND    #$03
		TAY
		PLA
		PHP
		lsr
		lsr
		PLP
		AND    #$07
		BEQ    LF3BB
		EOR    #$07
		BNE    LF3C1
LF3BB: TAY
		INC    $A1,X
		BCC    LF3E2
		DEY
LF3C1: EOR    #$07
		CPY    #$03
		BCC    LF3E2
		LDA    $99
		lsr
		lsr
		LDA    $C7
		BCC    LF3D8
		STA    $C9
		asl
		EOR    $C7
		asl
		asl
		ROL    $C7
LF3D8: asl
		LDY    #$03
		ROL    $C7
		BMI    LF3E0
		INY
LF3E0: LDA    #$07
LF3E2: STA    $9B,X
		STY    $A7,X
		LDA    #$9F
		STA    $D0,X
LF3EA: LDA    $D0,X
		CMP    #$A0
		LDY    $9B,X
		BCS    LF3F6
		BNE    LF3F8
		STY    $A7,X
LF3F6: LDA    #$9F
LF3F8: JSR    LF5BD
		STY    $D6,X		;set cow coarse player position
		asl
		asl
		asl
		asl
		LDY    $9B,X
		ORA    LF7A3,Y
		AND    $96			;mask off invisible cows
		STA    $CA,X		;set cow NUSIZ and REFP mode
		LDA    $D6,X
		SBC    #$05
		EOR    #$80
		BPL    LF414
		STA    $D6,X
LF414:
		LDY		$E3,X		;get animation frame
		LDA		LF607,Y		;look up graphic pointer
		STA		$EC,X		;stash graphic pointer
		LDA		LF637,Y		;look up HMOVE pointer
		STA		$F2,X		;stash HMOVE pointer
		DEX					;next cow
		BMI		LF426		;exit if done
		JMP		LF317		;update next cow
LF426:
		LDA    $BE
		JSR    LF011
LF42B:
;		LDY    INTIM
;		BNE    LF42B
		STA    WSYNC
	
		;----- end vertical blank	
		pha
		txa
		pha
		tya
		pha
		
		jsr		update8
		lda		#16/2
		cmp:rne	vcount
		
		pla
		tay
		pla
		tax
		pla
		
		ldy		#0
		STY    VBLANK
		STY    COLUPF
		LDY    #$A5
LF438: LDA    $B6,X
		lsr
		JSR    LF018
		LDA    $B8,X
		JSR    LF015
		BPL    LF438
		JSR    DrawScore
		JSR    LF15B
		LDY    #$01
		JSR    LF7E4
		LDA    #$83
		SBC    $B6
		TAY
		STX    NUSIZ0
		LDA    #$0A
		SBC    $C0
		TAX
		STA    HMCLR
		JSR    LF038
		STX    VDELP1
		LDA    #$07
		STA    $98
		LDY    #$04
		JSR    LF7E4
		INX
		STX    NUSIZ1
		LDY    #$05
		LDA    #$1E
		JSR    LF7E4
		STA    $F8
		LDX    #$0A
		STX    _audv1
		LDA    #<$4670
		LDY    #>$4670
LF480: STY    $80,X
		STY    $8A,X
		DEX
		STA    $80,X
		SBC    #$08
		DEX
		BNE    LF480
		STX    _audc1
		LDA    $C8
		AND    #$07
		TAY
		LDA    LF6F0,Y
		STA    $89
		JSR    LF7B0
		LDX    #$1C
		STX    HMP0
		STX    HMP1
		INC    $8C
		INC    $90
		LDA    #$23
		STA    WSYNC
		;STA    HMOVE
		STA    VBLANK
		
		lda		#248/2
		cmp:rne	vcount
		
		STA    TIM64T
		SEC
		LDA    $B8
		SBC    $B9
		LDA    $BC
		SBC    $BD
		BEQ    LF4D0
		LDA    $80
		lsr
		SED
		TYA
		ADC    $B8
		STA    $B8
		AND    #$01
		BNE    LF4CA
		STX    _audc1
LF4CA: TYA
		ADC    $BC
		STA    $BC
		CLD
LF4D0: LDX    #$FF
		LDA    $B3
		SEC
		SBC    #$14
		CMP    #$0E
		BCS    LF52D
		TAY
		ADC    #$0A
		SBC    $C0
		ADC    $B6
LF4E2: INX
		SBC    #$14
		BPL    LF4E2
		LDA    $9B,X
		BEQ    LF52D
		LDA    $A7,X
		CMP    #$04
		BCS    LF52D
		LDA    $DC,X		;get collision flags
		asl
		BPL    LF52D
		TYA
		EOR    #$0F
		asl
		asl
		ADC    #$2A
		JSR    LF585
		BCS    LF52D
		LDA    #$28
		SBC    $B3
		STA    $B3
		LDY    $A7,X
		STY    $DC,X
		LDA    LF6F8,Y
		SED
		ADC    $B9
		STA    $B9
		BCC    LF52C
		LDA    #$00
		ADC    $BD
		STA    $BD
		BCC    LF520
		INC    $C8
LF520: AND    #$0F
		BNE    LF52C
		LDA    $BE
		CMP    #$09
		BCS    LF52C
		INC    $BE
LF52C: CLD
LF52D: LDX    #$05
		LDA    $B6
		CLC
		ADC    #$7C
		SBC    $C0
LF536: CLC
		ADC    #$14
		TAY
		CMP    #$E1
		ror
		AND    $DC,X
		BPL    LF553
		LDA    $A7,X
		CMP    #$03
		BCS    LF575
		LDA    $AD,X
		BMI    LF553
		ADC    #$A0
		BCC    LF551
		LDA    #$FF
LF551: STA    $AD,X
LF553: TYA
		DEX
		BPL    LF536
		LDA    $99
		lsr
		BCC    LF572
		LDA    $B5
		ORA    $9A
		AND    #$3C
		BNE    LF572
LF564: EOR    $B7
		STA    $B7
		ADC    $C0
		STA    $C0
		CMP    #$0A
		LDA    #$FE
		BCS    LF564
LF572: JMP    LF1B5
LF575: BEQ    LF57B
		CPY    #$EB
		BCC    LF553
LF57B: LDA    #$E1
		STA    $B4
		LDA    #$FF
		STA    $B3
		BNE    LF553
LF585: SEC
		SBC    $D0,X
		lsr
		lsr
		lsr
		lsr
		TAY
		LDA    LF5ED,Y
		CPY    #$04
		BCC    LF597
		BNE    LF5BC
		DEY
LF597: STY    $95
		LDY    $9B,X
		AND    LF5E6,Y
		SEC
		BEQ    LF5BC
		LDA    $95
		BNE    LF5AF
		LDA    LF5E6,Y
		CLC
		AND    #$70
		ADC    $D0,X
		STA    $D0,X
LF5AF: TYA
		asl
		asl
		ORA    $95
		TAY
		LDA    LF6A7,Y
		AND    #$07
		STA    $9B,X
LF5BC: RTS

;==========================================================================
.proc LF5BD
		TAY
		CPY    #$60
		rol
		CPY    #$80
		rol
		CPY    #$90
		rol
		ORA    #$F8
		EOR    #$07
		STA    $96
		INY
		TYA
		AND    #$0F
		STA    $95
		TYA
		lsr
		lsr
		lsr
		lsr
		TAY
		CLC
		ADC    $95
		CMP    #$0F
		BCC    LF5E3
		SBC    #$0F
		INY
LF5E3: EOR    #$07
		RTS
.endp

;==========================================================================
.if 0
LF7B0: LDY    #$07
LF7B2: DEY
		LDA    ($89),Y
		asl
		LDX    $F8
		STA    WSYNC
		STX    colpm0
		STA    grafp0
		LDA    ($85),Y
		STA    grafp1
		LDA    ($83),Y
		TAX
		TXS
		LDA    ($87),Y
		TAX
		LDA    ($81),Y
		STY    $95
		LDY    $F9
		STY    colpm0
		STX    grafp0
		TSX
		STX    grafp0
		STA    grafp1
		LDY    $95
		BNE    LF7B2
		STY    grafp0
		STY    grafp1
		LDX    #$FD
		TXS
		RTS
.else
.proc LF7B0
		ldy		#$07
LF7B2	dey
		lda		$F8
		sta		wsync
		sta		colpf0
		ldx		row_offsets,y
		lda		($89),y
		asl
		sta		pf_banner+$04,x
		lda		($85),y
		sta		pf_banner+$10,x
		lda		($87),y
		sta		pf_banner+$0f,x
		lda		($83),y
		sta		pf_banner+$11,x
		lda		($81),y
		sta		pf_banner+$12,x
		tya
		bne		LF7B2
		
		sty		grafp0
		sty		grafp1
		rts
		
row_offsets:
		:7 dta 20*[6-#]
.endp
.endif

;==========================================================================
.proc DrawScore
		ldy		#$07
LF7B2	dey
		lda		$F8
		sta		wsync
		sta		colpf0
		ldx		LF7B0.row_offsets,y
		lda		($89),y
		asl
		sta		pf_score+$04,x
		lda		($85),y
		sta		pf_score+$05,x
		lda		($87),y
		sta		pf_score+$10,x
		lda		($83),y
		sta		pf_score+$11,x
		lda		($81),y
		sta		pf_score+$12,x
		tya
		bne		LF7B2
		
		sty		grafp0
		sty		grafp1
		rts
.endp

;==========================================================================
; Sprite coloring and positioning routine
;
; Input:
;	A = fine position
;	X = object
;			0 = player 0
;			1 = player 1
;			2 = missile 0
;			3 = missile 1
;	Y = gross position
;
; Preserved:
;	X
;
.proc LF7E4
		sta		wsync
		clc
		adc		horiz_tab,y
		sta		wsync
		sta		hposp0,x
		LDA    $F8,X
		cpx		#3
		beq		set_bk
		sta		colpm0,X
		rts
set_bk:
		sta		colbk
		rts
		
horiz_tab:
		:80 dta <[15*#]
.endp

;==========================================================================
cow_htab:
		:80 dta <[15*#+40]

;==========================================================================
		org		$4000
dlist:
		dta		$70
		dta		$70
		dta		$70
		dta		$4C,a(pf_score)
		:6 dta	$0C
		:14 dta	$70
		dta		$4C,a(pf_banner)
		:6 dta	$0C
		dta		$41,a(dlist)

		opt		o-		
pf_score:
		.ds		20*7
pf_banner:
		.ds		20*7

		opt		o+
		
;==========================================================================
		org		$45e6

LF5E6: .byte $01,$01,$13,$25,$17,$49,$2D
LF5ED: .byte $01,$02,$04,$00
LF5F1: .byte $08,$21,$1F,$1A,$1F

;==========================================================================
; player animation frame pointers
;
LF5F6:	.byte	<LF71A
		.byte	<LF700
		.byte	<LF700
		.byte	<LF700
		.byte	<LF734

;==========================================================================
LF5FB: .byte $2E,$2A,$22,$00,$0E,$3C,$66,$66,$66,$66,$66,$3C


;==========================================================================
LF607:	.byte	$8B,$7E,$18,$18,$18,$18,$78,$38
		.byte	$7D,$7E,$60,$60,$3C,$06,$46,$7C
		.byte	$6E,$3C,$46,$06,$0C,$06,$46,$3C
		.byte	$7D,$0C,$0C,$7E,$4C,$2C,$1C,$0C
		.byte	$7D,$7C,$46,$06,$7C,$60,$60,$7E
		.byte	$9B,$3C,$66,$66,$7C,$60,$62,$3C
		
LF637:	.byte	$AC,$18,$18,$18,$0C,$06,$42,$7E
		.byte	$C9,$3C,$66,$66,$3C,$66,$66,$3C
		.byte	$C9,$3C,$46,$06,$3E,$66,$66,$3C
		.byte	$C9,$E9,$AB,$AF,$AD,$E9,$00,$00
		.byte	$BA,$BA,$8A,$BA,$A2,$3A,$80,$FE
		.byte	$A4,$50,$58,$5C,$56,$53,$11,$F0
		
		.byte $00,$AD,$A9,$E9,$A9,$ED,$41,$0F

LF66F:	.byte	%00001100 ;$0C
		.byte	%00101000 ;$28
		.byte	%01010100 ;$54
		.byte	%10101100 ;$AC
		.byte	%10101010 ;$AA
		.byte	%11111110 ;$FE
		.byte	%01111111 ;$7F
		.byte	%01111110 ;$7E
		.byte	%01111110 ;$7E
		.byte	%11111101 ;$FD
		.byte	%01111111 ;$7F
		.byte	%00011100 ;$1C
		.byte	%00011000 ;$18
		.byte	%00100100 ;$24
		.byte	%00000000 ;$00
		
LF67E:	.byte	$15,$A5,$A5,$A5,$AA,$FE,$BF,$FE,$7C,$FA,$7E,$38,$30,$48
LF68C:	.byte	$00,$A0,$85,$A2,$A5,$AA,$FE,$7F,$BF,$F8,$FA,$3F,$0E,$0C,$12,$00
LF69C:	.byte	$03,$05,$0E,$1E,$3C,$54,$BA,$82,$44

LF6A5:	.byte	$00,$00
LF6A7:	.byte	$00,$00,$00,$00,$00,$00,$00,$30
		.byte	$E1,$11,$00,$00,$E1,$00,$31,$10
		.byte	$02,$03,$02,$00,$E1,$00,$00,$01
		.byte	$03,$20,$F5,$F3,$E0,$F0,$F0,$00
		
LF6C7:
		.byte	$00,$20,$00
		.byte	$20,$00,$00,$00,$00,$E0,$10,$10,$20,$10,$10,$00,$00
		.byte $90
LF6D8: .byte $38,$18,$08,$D8,$D0,$42,$B2,$22,$C2,$C2,$C2,$C2,$C2,$C2,$C2,$C2
		.byte $C2,$C2,$C2,$C2,$C2,$C2,$C2,$C2
LF6F0: .byte $A5,$95,$10,$18,$20,$28,$30,$38
LF6F8: .byte $24,$14,$02
LF6FB: .byte $99,$2C,$8C,$0C,$D6

;==========================================================================
; player graphic and HMOVE tables
;
LF700:	.byte	$00,$A0,$05,$A0,$05,$A0,$05,$A0,$A5,$FF,$FF,$FE,$FE,$FE,$7F,$FF
		.byte	$5D,$FF,$DE,$DC,$D8,$E0,$28,$63,$F1,$18
LF71A:	.byte	$00,$0A,$28,$10,$14,$28,$0A,$50,$A5,$FF,$FF,$FE,$FE,$FE,$7F,$FF
		.byte	$5D,$FF,$DE,$DC,$D8,$E0,$28,$63,$F1,$18
LF734:	.byte	$61,$C3,$C3,$E3,$E7,$F7,$FF,$FF,$3D,$3D,$3D,$3D,$3F,$3E,$1E,$0F
		.byte	$3F,$5D,$FF,$DE,$FC,$D8,$2F,$66,$66		;!! 1 byte shared with next table!
LF74D:	.byte	$26,$75,$A5,$55,$C5,$35,$E5,$15,$05,$05,$05,$05,$15,$F5,$55,$15
		.byte	$15,$15,$15,$15,$05,$D5,$45,$00,$E0
LF766:	.byte	$00,$E5,$25,$F5,$05,$05,$F5,$05,$05,$05,$05,$05,$15,$F5,$55,$15
		.byte	$15,$15,$15,$15,$05,$D5,$45,$00,$E0
LF77F:	.byte	$00,$F0,$F2,$02,$F0,$00,$02,$B0,$17,$15,$1D,$0F,$1D,$F5,$F7,$55
		.byte	$15,$1F,$1F,$15,$1F,$D7,$00,$00,$00

;==========================================================================
; Reset data (12 bytes)
;
LF798:	.byte	$70,$03,$40,$03,$03,$24,$63,$05,$44,$25,$AA

;==========================================================================
; cow NUSIZ / reflect table
LF7A3:
		dta		$00		;single
		dta		$00		;single
		dta		$01		;two copies close
		dta		$02		;two copies medium
		dta		$03		;three copies close
		dta		$04		;two copies wide
		dta		$06		;three copies medium
		dta		$08		;single, reflected
		
;==========================================================================
; player HMOVE animation frame pointers
;
LF7AB:	.byte	<LF74D
		.byte	<LF766
		.byte	<LF74D
		.byte	<LF766
		.byte	<LF77F

;==========================================================================
		org		$47fc
LF7FC: .byte $00
LF7FD: .byte $F0,$E0,$C0

		run		__init
